



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Go】优雅的读取http请求或响应的数据-续</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Go】优雅的读取http请求或响应的数据-续</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 11:19:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>原文链接：<a href="https://blog.thinkeridea.com/201902/go/you_ya_de_du_qu_http_qing_qiu_huo_xiang_ying_de_shu_ju_2.html" rel="external nofollow noreferrer">https://blog.thinkeridea.com/201902/go/you_ya_de_du_qu_http_qing_qiu_huo_xiang_ying_de_shu_ju_2.html</a></p>
<p>之前发布 <a href="https://blog.thinkeridea.com/201901/go/you_ya_de_du_qu_http_qing_qiu_huo_xiang_ying_de_shu_ju.html" rel="external nofollow noreferrer">【Go】优雅的读取http请求或响应的数据</a> 文章，网友 “wxe” 咨询：“优化前后的请求耗时变化有多大”，之前只分析了内存分配，这篇文章用单元测试的方式分析优化前后的耗时情况，<a href="https://github.com/thinkeridea/example/tree/master/iouitl_readall" rel="external nofollow noreferrer">本文源码</a>。</p>
<p>非常感谢 “wxe” 网友的提问，让我在测试过程中发现一个 <code>json</code> 序列化的问题。</p>
<p>之前我们优化了两个部分，<code>json</code> 与 <code>ioutil.ReadAll</code>， 先对比 <code>ioutil.ReadAll</code>, 这里测试的代码分成两个部分做对比，一部分单纯对比 <code>ioutil.ReadAll</code> 和 <code>io.Copy</code> + <code>sync.Pool</code>，另一部分增加 <code>jsoniter.Unmarshal</code> 来延迟 <code>pool.Put(buffer)</code> 的执行, <a href="https://github.com/thinkeridea/example/blob/master/iouitl_readall/io.go" rel="external nofollow noreferrer">源码</a>。</p>
<pre class="prettyprint linenums"><code>package iouitl_readall

import (<br />
	&quot;bytes&quot;<br />
	&quot;io&quot;<br />
	&quot;io/ioutil&quot;<br />
	&quot;sync&quot;

	jsoniter &quot;github.com/json-iterator/go&quot;<br />
)

var pool = sync.Pool{<br />
	New: func() interface{} {<br />
		return bytes.NewBuffer(make([]byte, 4096))<br />
	},<br />
}

func IoCopyAndJson(r io.Reader) error {<br />
	buffer := pool.Get().(*bytes.Buffer)<br />
	buffer.Reset()<br />
	defer pool.Put(buffer)

	res := Do(r)<br />
	_, err := io.Copy(buffer, res)<br />
	if err != nil {<br />
		return err<br />
	}

	m := map[string]string{}<br />
	err = jsoniter.Unmarshal(buffer.Bytes(), &amp;m)<br />
	return err<br />
}

func IouitlReadAllAndJson(r io.Reader) error {<br />
	res := Do(r)<br />
	data, err := ioutil.ReadAll(res)<br />
	if err != nil {<br />
		return err<br />
	}

	m := map[string]string{}<br />
	err = jsoniter.Unmarshal(data, &amp;m)<br />
	return err<br />
}

func IoCopy(r io.Reader) error {<br />
	buffer := pool.Get().(*bytes.Buffer)<br />
	buffer.Reset()<br />
	defer pool.Put(buffer)

	res := Do(r)<br />
	_, err := io.Copy(buffer, res)<br />
	if err != nil {<br />
		return err<br />
	}

	return err<br />
}

func IouitlReadAll(r io.Reader) error {<br />
	res := Do(r)<br />
	data, err := ioutil.ReadAll(res)<br />
	if err != nil {<br />
		return err<br />
	}<br />
	_ = data<br />
	return err<br />
}<br />
</code></pre>
<p>测试代码如下<a href="https://github.com/thinkeridea/example/blob/master/iouitl_readall/io_test.go" rel="external nofollow noreferrer">源码</a>:</p>
<pre class="prettyprint linenums"><code>package iouitl_readall

import (<br />
	&quot;bytes&quot;<br />
	&quot;testing&quot;<br />
)

var data = bytes.Repeat([]byte(&quot;ABCD&quot;), 1000)

func BenchmarkIouitlReadAll(b *testing.B) {<br />
	b.RunParallel(func(pb *testing.PB) {<br />
		for pb.Next() {<br />
			err := IouitlReadAll(bytes.NewReader(data))<br />
			if err != nil {<br />
				b.Error(err.Error())<br />
			}<br />
		}<br />
	})<br />
}

func BenchmarkIoCopy(b *testing.B) {<br />
	b.RunParallel(func(pb *testing.PB) {<br />
		for pb.Next() {<br />
			err := IoCopy(bytes.NewReader(data))<br />
			if err != nil {<br />
				b.Error(err.Error())<br />
			}<br />
		}<br />
	})<br />
}

func BenchmarkIouitlReadAllAndJson(b *testing.B) {<br />
	b.RunParallel(func(pb *testing.PB) {<br />
		for pb.Next() {<br />
			err := IouitlReadAllAndJson(bytes.NewReader(data))<br />
			if err != nil {<br />
				b.Error(err.Error())<br />
			}<br />
		}<br />
	})<br />
}

func BenchmarkIoCopyAndJson(b *testing.B) {<br />
	b.RunParallel(func(pb *testing.PB) {<br />
		for pb.Next() {<br />
			err := IoCopyAndJson(bytes.NewReader(data))<br />
			if err != nil {<br />
				b.Error(err.Error())<br />
			}<br />
		}<br />
	})<br />
}<br />
</code></pre>
<p>测试结果如下:</p>
<pre class="prettyprint linenums"><code>goos: darwin<br />
goarch: amd64<br />
pkg: github.com/thinkeridea/example/iouitl_readall<br />
BenchmarkIouitlReadAll-8          	  500000	      2752 ns/op	   14496 B/op	       6 allocs/op<br />
BenchmarkIoCopy-8                 	20000000	        65.2 ns/op	      48 B/op	       1 allocs/op<br />
BenchmarkIouitlReadAllAndJson-8   	  100000	     20022 ns/op	   46542 B/op	     616 allocs/op<br />
BenchmarkIoCopyAndJson-8          	  100000	     17615 ns/op	   32102 B/op	     611 allocs/op<br />
</code></pre>
<p>结论：</p>
<p>可以发现 <code>IoCopy</code> 方法是 <code>IouitlReadAll</code> 方法效率的 40 倍，内存分配也很少，而 <code>IoCopyAndJson</code> 和 <code>IouitlReadAllAndJson</code> 的效率差异极小仅有 <code>2407ns</code>，大约是 1.13倍，不过内存分配还是少了很多的，为什么会这样呢，这就是 <code>sync.Pool</code> 的导致的，<code>sync.Pool</code> 每次获取使用时间越短，命中率就越高，就可以减少创建新的缓存，这样效率就会大大提高，而 <code>jsoniter.Unmarshal</code> 很耗时，就导致 <code>sync.Pool</code> 的命中率降低了，所以性能下降极其明显.</p>
<p>使用 <code>io.Copy</code> + <code>sync.Pool</code> 表面上执行效率不会有很大提升，但是会大幅度减少内存分配，从而可以减少 <code>GC</code> 的负担，在单元测试中我们并没有考虑 <code>GC</code> 的问题，而 <code>GC</code> 能带来的性能提升会更有优势。</p>
<p>在看一下 <code>json</code> 使用 <code>sync.Pool</code> 的效果吧 <a href="https://github.com/thinkeridea/example/blob/master/iouitl_readall/json.go" rel="external nofollow noreferrer">源码</a></p>
<pre class="prettyprint linenums"><code>package iouitl_readall

import (<br />
	&quot;bytes&quot;<br />
	&quot;encoding/json&quot;

	jsoniter &quot;github.com/json-iterator/go&quot;<br />
)

func Json(r map[string]string) error {<br />
	data, err := json.Marshal(r)<br />
	if err != nil {<br />
		return err<br />
	}

	_ = data<br />
	return nil<br />
}

func JsonPool(r map[string]string) error {<br />
	buffer := pool.Get().(*bytes.Buffer)<br />
	buffer.Reset()<br />
	defer pool.Put(buffer)

	e := json.NewEncoder(buffer)<br />
	err := e.Encode(r)<br />
	if err != nil {<br />
		return err<br />
	}

	return nil<br />
}

func JsonIter(r map[string]string) error {<br />
	data, err := jsoniter.Marshal(r)<br />
	if err != nil {<br />
		return err<br />
	}

	_ = data<br />
	return nil<br />
}

func JsonIterPool(r map[string]string) error {<br />
	buffer := pool.Get().(*bytes.Buffer)<br />
	buffer.Reset()<br />
	defer pool.Put(buffer)

	e := jsoniter.NewEncoder(buffer)<br />
	err := e.Encode(r)<br />
	if err != nil {<br />
		return err<br />
	}

	return nil<br />
}<br />
</code></pre>
<p>性能测试代码<a href="https://github.com/thinkeridea/example/blob/master/iouitl_readall/json_test.go" rel="external nofollow noreferrer">源码</a>:</p>
<pre class="prettyprint linenums"><code>package iouitl_readall

import (<br />
	&quot;strconv&quot;<br />
	&quot;strings&quot;<br />
	&quot;testing&quot;<br />
)

var request map[string]string

func init() {<br />
	request = make(map[string]string, 100)<br />
	for i := 0; i &lt; 100; i++ {<br />
		request[&quot;X&quot;+strconv.Itoa(i)] = strings.Repeat(&quot;A&quot;, i/2)<br />
	}<br />
}<br />
func BenchmarkJson(b *testing.B) {<br />
	b.RunParallel(func(pb *testing.PB) {<br />
		for pb.Next() {<br />
			err := Json(request)<br />
			if err != nil {<br />
				b.Error(err.Error())<br />
			}<br />
		}<br />
	})<br />
}

func BenchmarkJsonIter(b *testing.B) {<br />
	b.RunParallel(func(pb *testing.PB) {<br />
		for pb.Next() {<br />
			err := JsonIter(request)<br />
			if err != nil {<br />
				b.Error(err.Error())<br />
			}<br />
		}<br />
	})<br />
}

func BenchmarkJsonPool(b *testing.B) {<br />
	b.RunParallel(func(pb *testing.PB) {<br />
		for pb.Next() {<br />
			err := JsonPool(request)<br />
			if err != nil {<br />
				b.Error(err.Error())<br />
			}<br />
		}<br />
	})<br />
}

func BenchmarkJsonIterPool(b *testing.B) {<br />
	b.RunParallel(func(pb *testing.PB) {<br />
		for pb.Next() {<br />
			err := JsonIterPool(request)<br />
			if err != nil {<br />
				b.Error(err.Error())<br />
			}<br />
		}<br />
	})<br />
}<br />
</code></pre>
<p>测试结果如下:</p>
<pre class="prettyprint linenums"><code>goos: darwin<br />
goarch: amd64<br />
pkg: github.com/thinkeridea/example/iouitl_readall<br />
BenchmarkJson-8                   	  100000	     13297 ns/op	   13669 B/op	     207 allocs/op<br />
BenchmarkJsonPool-8               	  100000	     13310 ns/op	   10218 B/op	     206 allocs/op<br />
BenchmarkJsonIter-8               	  500000	      2948 ns/op	    3594 B/op	       4 allocs/op<br />
BenchmarkJsonIterPool-8           	  200000	      6126 ns/op	    6040 B/op	     144 allocs/op<br />
PASS<br />
ok  	github.com/thinkeridea/example/iouitl_readall	12.716s<br />
</code></pre>
<p>这里使用了两个 <code>json</code> 包， 一个是标准库的，一个是 <code>jsoniter</code> (也是社区反馈效率最高的)，对比两个包使用 <code>sync.Pool</code> 和不使用之间的差异，发现标准库 <code>json</code> 包使用后内存有少量减少，但是运行效率稍微下降了，差异不是很大，<code>jsoniter</code> 包差异之所谓非常明显，发现使用 <code>sync.Pool</code> 之后不仅内存分配更多了，执行效率也大幅度下降，差了将近3倍有余。</p>
<p>是不是很奔溃，这是啥情况 <code>jsoniter</code> 本身就使用了 <code>sync.Pool</code> 作缓冲，我们使用 <code>jsoniter.NewEncoder(buffer)</code> 创建一个序列化实例，但是其内部并没有直接使用 <code>io.Writer</code> 而是先使用缓冲序列化数据，之后写入 <code>io.Writer</code>, 具体代码如下：</p>
<pre class="prettyprint linenums"><code>// Flush writes any buffered data to the underlying io.Writer.<br />
func (stream *Stream) Flush() error {<br />
	if stream.out == nil {<br />
		return nil<br />
	}<br />
	if stream.Error != nil {<br />
		return stream.Error<br />
	}<br />
	n, err := stream.out.Write(stream.buf)<br />
	if err != nil {<br />
		if stream.Error == nil {<br />
			stream.Error = err<br />
		}<br />
		return err<br />
	}<br />
	stream.buf = stream.buf[n:]<br />
	return nil<br />
}<br />
</code></pre>
<p>这样一来我们使用 <code>buffer</code> 做 <code>json</code> 序列化优化效果就大打折扣，甚至适得其反了。</p>
<p>再次感谢 “wxe” 网友的提问，这里没有使用实际的应用场景做性能测试，主要发现在性能测试中使用 <code>http</code> 服务会导致 <code>connect: can't assign requested address</code> 问题，所以测试用使用了函数模拟，如果有朋友有更好的测试方法欢迎一起交流。</p>
<p><strong>转载：</strong></p>
<p><strong>本文作者： 戚银（<a href="https://blog.thinkeridea.com/" rel="external nofollow noreferrer">thinkeridea</a>）</strong></p>
<p><strong>本文链接： <a href="https://blog.thinkeridea.com/201902/go/you_ya_de_du_qu_http_qing_qiu_huo_xiang_ying_de_shu_ju_2.html" rel="external nofollow noreferrer">https://blog.thinkeridea.com/201902/go/you_ya_de_du_qu_http_qing_qiu_huo_xiang_ying_de_shu_ju_2.html</a></strong></p>
<p><strong>版权声明： 本博客所有文章除特别声明外，均采用 <a href="http://creativecommons.org/licenses/by/4.0/deed.zh" rel="external nofollow noreferrer">CC BY 4.0 CN协议</a> 许可协议。转载请注明出处！</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqllv21q.html">解决ora-01652无法通过128（在temp表空间中）扩展temp段的过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m24o2q.html">WebLogic12&period;1&period;1中跨域问题的探讨以及几种常见中间件中跨域问题的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kg4z39.html">回顾Spring框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gwe1l8.html">JAVA软件开发职责</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvz45jq.html">flume ng配置拓扑图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydgo5gq.html">UVA 315 315 - Network（求割点个数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0v77eq.html">wampsever在win10中安装扩展掉坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ozke39.html">iOS7适配之设计篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok200e9.html">csdn博客刷粉代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1x34n9.html">WMS</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnggy08.html">C&num;快速排序法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05m60q.html">Gson源码分析之Json结构抽象和注解使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey5v6x9.html">简单js</a>
		</li>
						<li><a href="https://www.batexi.com/a/950y3d08.html">C&plus;&plus;课程设计类作业3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj0enx8.html">JDBC（四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pw3z48.html">Linux 删除目录与文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1jom09.html">git add&period;后回退 代码丢失</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4w24j9.html">Vue&colon;Promise概要</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy6v7dq.html">QChart绘制折线区域</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjx0v79.html">Maven 安装 on centos7</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlllmn1q.html">POI导入和导出Excel总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m22n5rq.html">mybatis批量更新报错badsql</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxddk7e9.html">如何下载官网上下载历史Java版本（老版本Java）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyyyy39.html">JavaScriptDOM</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gggweq.html">android&colon;动态申请权限（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m22d72q.html">Node&period;js 开发指南</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wwd6gq.html">java导出2007版word（docx格式）freemarker &plus; xml 实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv22zwj9.html">Redisson碰到的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e44o1m9.html">C&plus;&plus;的用法心得</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdd5g09.html">Visual Studio 开发（一）：安装配置Visual Studio Code</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
